# Esercizio Ring Loading
param n;        # Numero di vertici
set N := 1..n;  # Insieme indicizzato dei vertici
param t {N,N};	# Traffico previsto per ogni coppia ordinata di vertici

# VARIABILI
var x {N,N} binary;		# 0 = orario, 1 = antiorario
var alfa >= 0;			# Max traffico su un arco

# VINCOLI
subject to traffico {k in N}:
  alfa >= sum {i in N, j in N: (i<j) and (j<=k)} t[i,j]*x[i,j]
        + sum {i in N, j in N: (j<i) and (i<=k)} t[i,j]*(1-x[i,j])
        + sum {i in N, j in N: (i<=k) and (j>k)} t[i,j]*(1-x[i,j])
        + sum {i in N, j in N: (j<=k) and (i>k)} t[i,j]*x[i,j]
        + sum {i in N, j in N: (i>k) and (j>i)} t[i,j]*x[i,j]
        + sum {i in N, j in N: (j>k) and (i>j)} t[i,j]*(1-x[i,j]);

# OBIETTIVO
# Minimizzare max capacit necessaria
minimize z: alfa;

####################
data;

param n := 10;

param t:	1	2	3	4	5	6	7	8	9	10 :=
1   		9   7   7   8   7   9   9   6   6  10
2   		7   7   7   7   7   8   5   7  10   9
3   		7   5   8   8   8  10   6  10   9  10
4   		7  10   7  10   9   8   5  10   7   9
5  			10  5   6  10   5   8   7   9   8   7
6   		6   7   8   7   8  10   9   5   9   7
7   		9   5   8   9   7  10   8   9  10   7
8   		6   5   9   5   6   8  10   6   9   8
9   		7   5   5   8   8   8  10   7   9   7
10   		8   5   5   7   8   9   7   6   5   8;

end;
